namespace CMSMicroservice.Application.UserCartsCQ.Queries.GetUserCarts;
public class GetUserCartsQueryValidator : AbstractValidator<GetUserCartsQuery>
{
    public GetUserCartsQueryValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<GetUserCartsQuery>.CreateWithOptions((GetUserCartsQuery)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
